<?php if (!defined('APPLICATION')) exit();

// Define the plugin:
$PluginInfo['CivilTongue'] = array(
   'Name' => 'Civil Tongue',
   'Description' => 'A swear word filter for your forum. Making your forum safer for younger audiences.',
   'Version' => '0.3',
   'Author' => "Gary Mardell",
   'AuthorEmail' => 'gary@vanillaplugins.com',
   'AuthorUrl' => 'http://vanillaplugins.com',
   'SettingsUrl' => '/dashboard/plugin/tongue',
	'SettingsPermission' => 'Plugins.CivilTongue.Manage',
	'RegisterPermissions' => array('Plugins.CivilTongue.Manage')
);

class CivilTonguePlugin extends Gdn_Plugin {

	
	public function Base_GetAppSettingsMenuItems_Handler(&$Sender) {
      $Menu = $Sender->EventArguments['SideMenu'];
      $Menu->AddLink('Forum', T('Civil Tongue'), 'plugin/tongue', 'Plugins.CivilTongue.Manage');
   }

	public function PluginController_Tongue_Create(&$Sender, $Args = array()) {
		$Sender->Permission('Plugins.CivilTongue.Manage');	
		$Sender->Form = new Gdn_Form();
		$Validation = new Gdn_Validation();
      $ConfigurationModel = new Gdn_ConfigurationModel($Validation);
		$ConfigurationModel->SetField(array('Plugins.CivilTongue.Words', 'Plugins.CivilTongue.Replacement'));
		$Sender->Form->SetModel($ConfigurationModel);
		
		
		if ($Sender->Form->AuthenticatedPostBack() === FALSE) { 
			
         $Sender->Form->SetData($ConfigurationModel->Data);    
      } else {
         $Data = $Sender->Form->FormValues();
			
         if ($Sender->Form->Save() !== FALSE)
            $Sender->StatusMessage = T("Your settings have been saved.");
      }

		$Sender->AddSideMenu('plugin/tongue');		
		$Sender->SetData('Title', T('Civil Tongue'));
		$Sender->Render($this->GetView('index.php'));
	
	}
	
	public function CommentModel_BeforeSaveComment_Handler(&$Sender) {
		$FormPostValues = $Sender->EventArguments['FormPostValues'];
		$Replacement = C('Plugins.CivilTongue.Replacement', '');
		$Patterns = $this->GetPatterns();
		
		if(count($Patterns) > 0) {
			$FormPostValues['Body'] = preg_replace($Patterns, $Replacement, $FormPostValues['Body']);			
			$Sender->EventArguments['FormPostValues'] = $FormPostValues;		
		}
	}
	

	public function DiscussionModel_BeforeSaveDiscussion_Handler(&$Sender) {
		$FormPostValues = $Sender->EventArguments['FormPostValues'];
		$Replacement = C('Plugins.CivilTongue.Replacement', '');
		$Patterns = $this->GetPatterns();
		
		if(count($Patterns) > 0) {
			$FormPostValues['Name'] = preg_replace($Patterns, $Replacement, $FormPostValues['Name']);		
			$FormPostValues['Body'] = preg_replace($Patterns, $Replacement, $FormPostValues['Body']);			
			$Sender->EventArguments['FormPostValues'] = $FormPostValues;		
		}
		
	}
	
	private function GetPatterns() {
		// Get config
		$Words = C('Plugins.CivilTongue.Words', null);
		$Patterns = array();
		
		if($Words !== null) {
			$ExplodedWords = explode(';', $Words);
			foreach($ExplodedWords as $Word) {
				$Patterns[] = '/\b' . preg_quote(ltrim(rtrim($Word))) . '\b/is';
			}
		}
		return $Patterns;
	}
	
	
   public function Setup() {
      // Set default configuration
		SaveToConfig('Plugins.CivilTongue.Replacement', '****');
		
   }
}

